%   image compression all
%tarin the sensing matrix using different algorithm,and reconstruct the
%image using the trained sensing matrices

clc;clear;close all;
load('traindata.mat')    %load the training data,which is obtained from the "LabelMe"
%load('Dic_CCS.mat')               %load the trained Dictionary and the corresponding Coeffcient matrix,which is obtained via K-SVD algorithm using the training data
addpath('./tool')
%param setting=============================================================
K = 4;                              %the sparsity
IterNum = 30;                       %number of iteration used in CS_S_DCS
M = 20;                             %the dimension of sensing matrix
%test different Images
pathForImages ='./images/';
% CS_CCS=======================================================
bb = 8; Pn = 10;
randn('seed',2017);rand('seed',2017);
DCT=zeros(bb,Pn);
for k=0:1:Pn-1,
    V=cos([0:1:bb-1]'*k*pi/Pn);
    if k>0, V=V-mean(V); end;
    DCT(:,k+1)=V/norm(V);
end;
DCT=kron(DCT,DCT);
Psi_0 = DCT;

alpha = .2; beta = 1;numPsi = 5;
[Phi_CCS,Psi_CCS] = learning_CCS(trainblkMatrix,M,Psi_0,alpha,beta,K,IterNum,numPsi);

for ii = 1:numPsi
    A_CCS(:,:,ii) = Phi_CCS*Psi_CCS(:,:,ii);
end

imageName = 'lena512.png';
%read the image=========================================================
image = imread(strcat([pathForImages,imageName]));
image = double(image);

image_or = image;
[image,mblk_I,nblk_I] = our_im2col(image,8);  % rearrange image
imageMeans = mean(image);
image = image-ones(size(image,1),1)*imageMeans; %remove the means
Y_CCS = Phi_CCS*image;     %get the mearsurement
%reconstruction
X_CCS = [];
for ii = 1:numPsi
    [S_CCS] = OMP(A_CCS(:,:,ii),Y_CCS,K);
    temp = Psi_CCS(:,:,ii)*S_CCS;
    temp = temp + ones(size(image,1),1)*imageMeans;
    X_CCS(:,:,ii) = our_col2im(temp,8,mblk_I,nblk_I);
end
X_CCS_avg = mean(X_CCS,3);
PSNR_CCS = calcu_psnr(image_or,X_CCS_avg)


