
% program for alternative optimization of measurement matrix and dictionary
% "Learning to Sense Sparse Signals: Simultaneous
% Sensing Matrix and Sparsifying Dictionary
% Optimization"

% Input:
%%%%%%%%%  X_0 - Original signal set of dimension N x P
%%%%%%%%%  Phi_0 - Initial measurement matix of dimension M x N
%%%%%%%%%  Psi_0 - Initial dictionary of dimension N x L
%%%%%%%%%  alpha_dic - A weighting factor in dictionary design
%%%%%%%%%  K - The sparsity
%%%%%%%%%  N_ite - The number of iteration in alternative optimization

% Output:
%%%%%%%%%  Phi_opt - Optimal output measurement matrix of dimension M x N
%%%%%%%%%  Psi_opt - Optimal output dictionary of dimension N x L

function [Phi_opt,Psi_opt]=CS_Bai(X,M,Psi_0,alpha,beta,K,N_ite)

[N,P]=size(X); [N3,L]=size(Psi_0);

mu_0 = sqrt((L-M)/M/(L-1));
Psi=Psi_0;

%[U_Psi,S_Psi,V_Psi] = svd(Psi); Phi = U_Psi(:,1:M)';
Phi = randn(M,N);
% mblk_I = 64; nblk_I = 64;
for i=1:N_ite
    
    %% Updating sensing
    
    Gd = Psi'*Psi; %rho_before = (1-beta)*norm(Gd - )
    for jj = 1:1
        A = normc(Phi*Psi);
        Gt = A'*A; Gt([1:L+1:L^2])=0;
        [index]=find(abs(Gt)>mu_0);
        Gt(index) = mu_0*sign(Gt(index)); Gt([1:L+1:L^2]) = 1;  
        Delta = (1-beta)*Gd + beta*Gt;      
        [Upsi,Spsi,Vpsi] = svd(Psi);
          tildeDelta = Vpsi'*Delta*Vpsi; Delta11 = tildeDelta(1:N,1:N);
          clear tildeDelta
          [Ve, Lambda,~] = svd(Delta11); Lambda(M+1:end,M+1:end) = 0;
          [V11,Sigma11,~] = svd(pinv(Spsi(1:N,1:N))*Ve*Lambda*Ve'*pinv(Spsi(1:N,1:N)));
          Phi = [sqrt(Sigma11(1:M,1:M)) zeros(M,N-M)]*V11'*Upsi';
%         [V11,Sigma11,~] = svds(Delta,M);
%         Phi = sqrt(Sigma11)*V11'*pinv(Psi);
    end
    %% Updating dictionary
    A = [sqrt(1-alpha)*Phi*X;sqrt(alpha)*X]; B = [sqrt(1-alpha)*Phi;sqrt(alpha)*eye(N)];
    for ii = 1:1
        S = OMP(B*Psi, A, K );
        Psi = normc(pinv(B)*A*pinv(S));
    end

end
%[U_Psi,S_Psi,V_Psi] = svd(Psi); Phi = U_Psi(:,1:M)';
Phi_opt=Phi;
Psi_opt=Psi;


