function [ SenMatr_opt ] = Closed_DCS( Dictionary, M )
%==========================================================================
%this funcution is corresponding to find the closed form solution to 
%Duarte's paper
%--------------------------------------------------------------------------
%Input:   - Dictionary, the fixed dictionary with dimension N*L and which
%           is assumed to be full row rank
%         - M, the row dimension of the sensing matrix
%--------------------------------------------------------------------------
%Output:  - SenMatr_opt, the optimizaed sensing matrix
%--------------------------------------------------------------------------
%
%                    Xiao LI   Aug.2015    at ZJUT
%==========================================================================

[N,L] = size(Dictionary);
[U_psi, S_psi, V_psi] = svd(Dictionary);
P = inv(S_psi(1:M,1:M));
P2 = zeros(M,N-M);
SenMatr_opt = [P,P2]*U_psi';
%examine some value
A = SenMatr_opt * Dictionary;
G_opt=A'*A;  
Del = eye(L) - G_opt;
trace(Del*Del'); 
end

