function [A,obj,coherence] = UNTF_frame(M,L,A0,nIter,mu_0)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Given M,L,mu, initialization F0,
%            we use IPR to design an incoherent frame.
% -- by LG and ZZ, Sep 2016.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Designing loop
iter = 1; A = A0;
obj = zeros(nIter,1); coherence = zeros(nIter,1);
while iter <= nIter
    A = normc(A);
    G = A'*A; G([1:L+1:L^2])=0;
    [index]=find(abs(G)>mu_0);  
    G(index) = mu_0*sign(G(index));
    G([1:L+1:L^2]) = 1;   
    [U ,S] = eig(G);
    [value index] = sort(diag(S),'descend');  
    A = diag(sqrt(max(value(1:M),0)))*(U(:,index(1:M)))';   
    A = sqrt(L/M)*(A*A')^(-1/2)*A;
    %%%  Compute the coherence and objective function and display
    
    obj(iter) = obj(iter) + norm(diag(A'*A)-1)^2;
    A_ = normc(A);
    G = A_'*A_; G([1:L+1:L^2])=0;
    [index]=find(abs(G)>mu_0);  
    obj(iter) =  obj(iter) + norm(G(index) - mu_0*sign(G(index)))^2;
    obj(iter) =  obj(iter) + norm(G(index) - mu_0*sign(G(index)))^2;
    coherence(iter) = max(max(abs(G)));
    fprintf('Total iterations of UNTF = %.0f, %.0f-th iterations, coherence = %.4f\n',...
        nIter,iter,coherence(iter));    
    iter = iter + 1;
end

