function [noiseData,actualNoise] = addNoisetoData_BH(testData,SNRdB)
%==========================================================================
%in this function,the signal with noise and the noise will be found
%corresponding to the specified SNR(dB).
%
%Input: tesedata,the pure signal that you want to add noise 
%       SNRdB,the expected SNR(dB)
%
%Output: noiseData,the signal with specified noise 
%        actulNoise,the nois you have add to the pure signal
%
%                        NOV. 2014
%==========================================================================

if (SNRdB==0) || (SNRdB == 80) 
    noiseData=testData;
else
    noise = randn(size(testData));
    actualNoise = calcNoiseFromSNR(SNRdB,testData, noise);
    noiseData =  testData + actualNoise;   
end


function  actualNoise = calcNoiseFromSNR(TargerSNR, signal, randomNoise)
signal_2 = sum(signal.^2);
ActualNoise_2 = signal_2./(10^(TargerSNR/10));
noise_2 = sum(randomNoise.^2);
ratio = ActualNoise_2./noise_2;
actualNoise = randomNoise.*repmat(sqrt(ratio),size(randomNoise,1),1);

