%%%%%%%%%%%%%%%%%%  Optimal sensing matrix based on Theorem2

function [G_opt,X_opt,V_d]=theorem2(V_11,Psi,M)

%%%%%%%%%  Psi - dictionary given of dimension N x L
%%%%%%%%%    M - no. of rows in the sensing matrix to be designed


[N, L] = size(Psi);   

[U_d,S_d,V_d]=svd(Psi);
N_r=rank(S_d);

%%%%%%%%%%%%
% V_11=eye(N_r);                %W=randn(N_r);  [V_11,p1,p2]=svd(W);
V_22=eye(L-N_r); 
Q=zeros(L); Q(1:N_r,1:N_r)=V_11;  Q(N_r+1:L,N_r+1:L)=V_22;

V_opt=V_d*Q;

%%%%%%%%%%%%%%%%%%%%%%%%%%
I_M=eye(M);   
U=I_M;   
if N > N_r
    P=zeros(N);  P(1:N_r,1:N_r)=V_11'*inv(S_d(1:N_r,1:N_r));
  else
    P=V_11'*inv(S_d(1:N_r,1:N_r));
end
X_opt=U*[I_M zeros(M,N-M)]*P*U_d';  %%%%%%% optimal sensing matrix: || I_L - Psi'*X'*X*Psi ||_F

%%%%%%%%%%%%%%%% verifying the program above
A=X_opt*Psi;

G_opt=A'*A;  %%%%%%%%%%%%


Del = eye(L) - A'*A;

trace(Del*Del');   %%%%%%%%%% should be equal to L-M