
% program for the alternative minimization - based alg. using Theorem3

%                 called optimal_measurement_matrix.m        

function[X_opt]= theorem3(Psi,M,N_iter)

%%%%%%%%%  Psi - dictionary given of dimension N x L
%%%%%%%%%    M - no. of rows in the sensing matrix to be designed

[n1, n2]=size(Psi);  N=n1;   L=n2;      
N_r=rank(Psi);
RES_LG=zeros(N_iter+1,1);
LB = sqrt((L-M)/(M*(L-1)))*1; 


V_11=eye(N_r);

[G,X_opt,V_d]=theorem2(V_11,Psi,M);

% calculate the u
    D_sc=diag(1./sqrt(diag(G)));
    G_n=D_sc*G*D_sc;   %%%%%% Normalized
    G_n_=G_n-eye(L);
    pos=find(abs(G_n(:))>LB);
    G_n2=abs(G_n(pos));
    RES_LG(1)=mean(G_n2);






evolution=zeros(1,N_iter+1);
evolution2=zeros(1,N_iter);
for k=1:N_iter
  %%%%%%%% Step I: Shrinking
  D_sc=diag(1./sqrt(diag(G)));
  G_n=D_sc*G*D_sc;   %%%%%% Normalized
  pos=find(abs(G_n(:))>LB & abs(G_n(:)-1)>1e-6);

  mu_t=mean(abs(G_n(pos)));  %%%%%%%%%%% averaged mu 
  evolution(k)=mu_t;  

  G_n(pos)=sign(G_n(pos))*LB;    %%%%%%%%  updating:   Shrinkaged Gram
  Delta=G_n;
  %%%%%%%%%% Step II: optimizing V_11
  Q=V_d'*Delta*V_d; Q_11=Q(1:N_r,1:N_r);
  [V_e,D_e]=eig(Q_11);
  V_p=V_e; D_p=sum(D_e);   
  for j=1:N_r
      [val, index]=max(D_p);
      V_p(:,j)=V_e(:,index); D_p(index)=-10^59; %% set it to the smallest element in D_p
  end
  V_11_opt=V_p;
  
  %%%%%%%%  Step III: updating V_11
  M_e= Delta - G; rho_1= trace(M_e'*M_e);
  
  [G_opt,X_opt,V_d]=theorem2(V_11_opt,Psi,M);
  M_e= Delta - G_opt; rho_2= trace(M_e'*M_e);
  
    G1=(X_opt*Psi)'*(X_opt*Psi);
    D_sc1=diag(1./sqrt(diag(G1)));
    G_n1=D_sc1*G1*D_sc1;   %%%%%% Normalized
    G_n_=G_n1-eye(L);
    pos=find(abs(G_n_(:))>LB);
    G_n2=abs(G_n1(pos));
    RES_LG(k+1,1)=mean(G_n2);
  
  
  
  
  
  if rho_2 < rho_1
      V_11=V_11_opt; G=G_opt;evolution2(k)=rho_2;
  else
      V_11=V_11; G=G;evolution2(k)=rho_1;
  end
end
[G_pp,X_opt,V_d]=theorem2(V_11,Psi,M);

  G_n=diag(1./sqrt(diag(G_pp)))*G_pp*diag(1./sqrt(diag(G_pp)));   %%%%%% Normalized
  pos=find(abs(G_n(:))>LB & abs(G_n(:)-1)>1e-6);
  mu_t=mean(abs(G_n(pos)));  %%%%%%%%%%% averaged mu 
  evolution(N_iter+1)=mu_t;

